/*
 * Copyright 2023 KylinSoft Co., Ltd.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */
#ifndef UPOWERBATTERYDBUS_H
#define UPOWERBATTERYDBUS_H

#include <QObject>
#include <QtDBus>
#include <QDBusInterface>

class UpowerBatteryDBus : public QObject
{
    Q_OBJECT
public:
    explicit UpowerBatteryDBus(int batteryId, const QString &batteryDBusPath, QObject *parent = nullptr);
    ~UpowerBatteryDBus();

private:
    void initBatteryInfo();

    int m_batteryId;

    QString m_batteryDBusPath;

    QDBusInterface *m_DBusInterface;

    bool m_batteryPresent;

    double m_percentage;

signals:
    void batteryInfoChanged(int, QStringList);

private slots:
    void dealBatteryPropertiesMessage(QDBusMessage);

public:
    bool batteryIsPresent();

    double getBatteryPercentage();

    void refreshBatteryInfo();
};

#endif // UPOWERBATTERYDBUS_H
