QT       += core dbus x11extras
QT       -= gui
greaterThan(QT_MAJOR_VERSION, 4): QT += widgets

TARGET = ukui-powermanagement-service
TEMPLATE = lib

CONFIG += console c++11 link_pkgconfig plugin
CONFIG -= app_bundle
 
LIBS += -lukui-log4qt -lpci -lukuiserviceinterface

DESTDIR = .
INCLUDEPATH += .
DEFINES += MODULE_NAME=\\\"pm\\\"
inst1.files += conf/org.ukui.powermanagement.service
inst1.path = /usr/share/dbus-1/system-services/
inst2.files += conf/org.ukui.powermanagement.conf
inst2.path = /etc/dbus-1/system.d/

target.source += $$TARGET
target.path = /usr/libexec/ukui-services/system
INSTALLS += \
    target \
    inst1 \
    inst2 \

upmHardwareGlobalConf.files += conf/upm-hardware-global.conf
upmHardwareGlobalConf.path = /usr/share/ukui/ukui-power-manager/

upmHardwareExtendConf.files += conf/extend-config/Lenovo.config
upmHardwareExtendConf.files += conf/extend-config/bxc.config
upmHardwareExtendConf.path = /usr/share/ukui/ukui-power-manager/upm-hardware-extend.d/

INSTALLS += upmHardwareGlobalConf upmHardwareExtendConf

DISTFILES += \
    metadata.json

HEADERS += \
    brightness-control/brightnessnode.h \
    common.h \
    cpu-control/upmcpucontrol.h \
    cpu-control/upmcpucoreinfo.h \
    cpu-control/upmcpuoccupy.h \
    dev-power-control/devpowercontrol.h \
    hardware-power-control/hardwarepowercontrol.h \
    powerconfig.h \
    sysdbusregister.h \
    dev-power-control/devicepowerinfo.h \
    dev-power-control/i2cdevice.h \
    dev-power-control/pcidevice.h \
    dev-power-control/satadevice.h \
    upmcommonfile.h \
    upmcustomhardwareconfig.h\
    powerservice.h

SOURCES += \
    brightness-control/brightnessnode.cpp \
    cpu-control/upmcpucontrol.cpp \
    cpu-control/upmcpucoreinfo.cpp \
    cpu-control/upmcpuoccupy.cpp \
    dev-power-control/devpowercontrol.cpp \
    hardware-power-control/hardwarepowercontrol.cpp \
    powerconfig.cpp \
    sysdbusregister.cpp \
    dev-power-control/devicepowerinfo.cpp \
    dev-power-control/i2cdevice.cpp \
    dev-power-control/pcidevice.cpp \
    dev-power-control/satadevice.cpp \
    upmcommonfile.cpp \
    upmcustomhardwareconfig.cpp\
    powerservice.cpp

